//hookexplorer.h

#ifndef _HOOKEXPLORER_
#define _HOOKEXPLORER_
#include "hooklistview.h"
#include "hookTreeview.h"
#include "ThreadData.h"
#include "resource.h"      
#include "..\exe\iconlock.h"	//shared equates


/////////////////////////////////////////////////////////////////////////////
// CHookExplorer
class CHookExplorer 
{
public:
	CHookExplorer();
    ~CHookExplorer();
	void UnSubclassWindows( );


public:
	int SubclassExplorer( );
	static BOOL CALLBACK WndEnumProc(HWND, LPARAM);
	static LRESULT CALLBACK ExplorerWndProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK CBTProc(int nCode, WPARAM wParam, LPARAM lParam);
	
	void DirectoryChange( LPCTSTR );
	void GetDesktopDirectories( );

private:   
	void SubClassTreeView( HWND hwnd );
	void SubClassListView( HWND hwnd );
	void DisableToolbarWindows( );
	HWND FindWindowClass( HWND, PTCHAR pClassName );
	HWND FindWindowClassThread( PTCHAR pClassName );
	static LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam);

public:
	UINT m_bLocked;				//explorer is viewing a desktop folder
	int  m_bLockFlags;			//lock options from IconDll.dll
	UINT m_PrivateMessage;		//private message from IconDll.dll
	HCURSOR m_hLockedCursor;

private:
	HWND    m_hwndExplorer;
	HHOOK   m_hKeyboardHook;
	HHOOK   m_hCBTHook;

	TCHAR   m_szCommonDestopDirectory[MAX_PATH];   	
	TCHAR   m_szDestopDirectory[MAX_PATH];
	TCHAR   m_szDesktopDir[MAX_PATH];
	TCHAR   m_szDesktop[MAX_PATH];
	WNDPROC m_TreeViewProc;
	WNDPROC m_ListViewProc;
	WNDPROC m_ExplorerOldWndProc;

public:	
	CHookListView m_ListView;
	CHookTreeView m_TreeView;

};

#endif //_HOOKEXPLORER_
